<?php
    define('PDEL_ENTRY_SCRIPT' , basename(__FILE__ , '.php'));
    define('PDEL_DOWNLOAD_DIR' , dirname(__FILE__) . DIRECTORY_SEPARATOR . 'download');
    require_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . '_router.php');
    if( $_SERVER["REQUEST_METHOD"] === 'GET' ){
		$html = <<< EOT
{PDEL-HEAD}
<body>
{PDEL-MENU}
{PDEL-MAIN-HTML}
{PDEL-FOOTER}
{PDEL-JS-LINK}
<script src="./public_assets/org/js/pdel_download.js"></script>
</body>
</html>
EOT;
		$html = str_replace('{PDEL-HEAD}' , genHeader() , $html);
        $html = str_replace('{PDEL-MENU}' , genTopNavi() , $html);
        $html = str_replace('{PDEL-MAIN-HTML}' , getMainHtml() , $html);
        $html = str_replace('{PDEL_USE_BOOTSTRAP_ICON_BTN}' , PDEL_USE_BOOTSTRAP_ICON_BTN , $html);
        $html = str_replace('{PDEL-FOOTER}' , genFooter() , $html);
		$html = str_replace('{PDEL-JS-LINK}' , genJsLink() , $html);
        $tr_form = <<< EOT_TR
                <tr>
                    <td class="pdel_td" style="text-align:center;vertical-align:middle">{PDEL_DOWNLOAD_VERSION}</td>
                    <td class="pdel_td" style="text-align:center;vertical-align:middle">{PDEL_DOWNLOAD_FILE_SIZE}</td>
                    <td class="pdel_td" style="vertical-align:middle">{PDEL_DOWNLOAD_HASH}</td>
                    <td class="pdel_td" style="text-align:center;vertical-align:middle">
                    <a class="{PDEL_DOWNLOAD_BUTTON}" href="./public_assets/_download/{PDEL_DOWNLOAD_ZIP}"><i class="{PDEL_USE_BOOTSTRAP_ICON_BTN_DOWN_LOAD}"></i><br>Download</a>
                    </td>
                    <td class="pdel_td" style="vertical-align:middle">{PDEL_VER_CURRENT}{PDEL_DOWNLOAD_SUMARY}</td>
                </tr>
EOT_TR;
        if( defined('PDEL_RELEASE_NOTES_DIR') === false ) die('Invalid download env ' . basename(__FILE__) . '(' . __LINE__ . ')');
        $release_info = scandir(realpath(PDEL_RELEASE_NOTES_DIR) , 1);
        if( $release_info === false ) die('Invalid download env ' . basename(__FILE__) . '(' . __LINE__ . ')');
        $tr_dl = '';
        $b_current = null;
        for($i=0;$i<count($release_info);$i++){
            if( ($release_info[$i] === '..') or ($release_info[$i] === '.') ) continue;
            $b_current = $b_current === null ? true : false;
            $file_name_info = explode('_', $release_info[$i]);
            if( count($file_name_info) !== 4 ) die('Invalid download env ' . basename(__FILE__) . '(' . __LINE__ . ')');
            switch(true){
                case ctype_digit($file_name_info[0]) === false:
                case ctype_digit($file_name_info[1]) === false:
                case ctype_digit($file_name_info[2]) === false:
                case ctype_digit($file_name_info[3]) === false:
                case strlen($file_name_info[0]) !== 8:
                    die('Invalid download env ' . basename(__FILE__) . '(' . __LINE__ . ') file_name=' . $release_info[$i]);
            }
            if( checkdate(intval(substr($file_name_info[0] , 4 , 2)) , intval(substr($file_name_info[0] , 6 , 2)) , intval(substr($file_name_info[0] , 0 , 4))) === false ) die('Invalid download env ' . basename(__FILE__) . '(' . __LINE__ . ') file_name=' . $release_info[$i]);
            $zip_file_name = realpath(PDEL_RELEASE_NOTES_DIR . '..' . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR . 'zip' . DIRECTORY_SEPARATOR . 'pdel4php5_' . $file_name_info[1] . '_' . $file_name_info[2] . '_' . $file_name_info[3] . '.zip');
            if(is_normal_file($zip_file_name) !== true ) die('Invalid download env ' . basename(__FILE__) . '(' . __LINE__ . ') file_name=' . $release_info[$i]);
            if( $tr_dl !== '' ) $tr_dl = $tr_dl . "\n";
            $tr_dl = $tr_dl . $tr_form;
            $tr_dl = str_replace('{PDEL_DOWNLOAD_VERSION}' , $file_name_info[1] . '.' . $file_name_info[2] . '.' . $file_name_info[3] . '<br>' .
                        substr($file_name_info[0] , 0 , 4) . '-' . substr($file_name_info[0] , 4 , 2) . '-' . substr($file_name_info[0] , 6 , 2) , $tr_dl);
            $tr_dl = str_replace('{PDEL_DOWNLOAD_FILE_SIZE}' , number_format(filesize($zip_file_name)) , $tr_dl);
            $tr_dl = str_replace('{PDEL_DOWNLOAD_HASH}' , sha1_file($zip_file_name) . '<br>' . md5_file($zip_file_name) , $tr_dl);
            $tr_dl = str_replace('{PDEL_DOWNLOAD_ZIP}' , basename($zip_file_name) , $tr_dl);
            $tr_dl = str_replace('{PDEL_VER_CURRENT}' , ($b_current ? '{PDEL_i18n_current}' : '') , $tr_dl);
            $tr_dl = str_replace('{PDEL_DOWNLOAD_SUMARY}' , file_get_contents(PDEL_RELEASE_NOTES_DIR . $release_info[$i]) , $tr_dl);
        }
        $html = str_replace('{pdel_download_tr}' , $tr_dl , $html);
        $html = str_replace('{PDEL_USE_BOOTSTRAP_ICON_BTN_DOWN_LOAD}' , PDEL_USE_BOOTSTRAP_ICON_BTN_DOWN_LOAD , $html);
        $html = str_replace('{PDEL_DOWNLOAD_BUTTON}' , 'btn btn-inverse' , $html);
        $html = getLocaleResource($html);
        $html = getCommonLocaleResource($html);
		echo $html;
    }
    else{
        if( function_exists('secure_log') === true ) secure_log(basename(__FILE__) . '(' . __LINE__ . ')');
        replyInvalidRequest(1);
    }