<?php
//定数定義ファイル
require_once PDEL_HOME . 'conf' . DIRECTORY_SEPARATOR . 'demo' . DIRECTORY_SEPARATOR . 'wrapper' . DIRECTORY_SEPARATOR . 'ConstDef8.inc';
//PDEL本体
require_once PDEL_HOME . 'engine'  . DIRECTORY_SEPARATOR . 'Pdel.php';
final class DemoWrapper8 extends Pdel
{
    public function __construct($s_ini_file = '' , $b_debug_mode = false)
    {
        /*
         * PDEL専用INIファイルに定義すべき情報が、PHPの定数として定義されており、
         * INIファイルに直接定義せず、専用セッターで設定するラッパークラスの例
         */
        //必ず最初にPDEL本体のコンストラクタを呼び出してください。
        parent::__construct($s_ini_file , $b_debug_mode);
        //PDEL専用INIファイルに定義されたUL_LIST_DELと同じものを用います。
        $delimiter = ',';
        //PDEL専用INIファイルのUL_LISTに設定する文字列を編集
        $user_level_list = PDEL_DEMO_STAFF_MANAGER . $delimiter .
                           PDEL_DEMO_STAFF_LEADER . $delimiter .
                           PDEL_DEMO_STAFF_STANDARD . $delimiter .
                           PDEL_DEMO_STAFF_BEGINNER;
        //セッターで設定
        $this->___setUserLevelString($user_level_list);
    }
    protected function ___error_proc($a_ret , $s_recipe_name)
    {
        /*
         * 独自エラー処理の実装例
         */
        if( $a_ret['status'] === false ){
            $s_err_msg = '';
            $s_info_msg = '';
            if( array_key_exists('result_type' , $a_ret) === false ){
                //暗号化時のエラー
                switch(substr($a_ret['detail'] , 0 , 1)){
                    case 'D':
                        //セッション・ハイジャック・チェックキー項目エラー
                        $s_err_msg = 'pdel critical error (recipe=' . $s_recipe_name . ') invalid session hijack check key::';
                        break;
                    default:
                        //上記以外
                }
            }
            else{
                //復号化時のエラー
                switch(substr($a_ret['detail'] , 0 , 1)){
                    case 'D':
                        //セッション・ハイジャック・チェックキー項目エラー
                        $s_err_msg = 'pdel critical error (recipe=' . $s_recipe_name . ') invalid session hijack check key::';
                        break;
                    case 'F':
                        //セッション・ハイジャック・チェックエラー
                        $s_err_msg = 'pdel critical error (recipe=' . $s_recipe_name . ') session hijacked::';
                        break;
                    case 'G':
                        //認証情報B不正(悪意のある第三者による攻撃)
                        $s_err_msg = 'pdel critical error (recipe=' . $s_recipe_name . ') invalid auth_inf_b::';
                        break;
                    case 'H':
                        //有効期限切れエラー
                        $s_info_msg = 'pdel info (recipe=' . $s_recipe_name . ') limit time check error::';
                        break;
                    default:
                        //上記以外
                }
            }
            if( ($s_err_msg !== '') or ($s_info_msg !== '') ){
                switch(true){
                    case array_key_exists('HTTP_CLIENT_IP' , $_SERVER):
                        $s_client_inf = 'HTTP_CLIENT_IP=' . $_SERVER['HTTP_CLIENT_IP'] . ' REMOTE_ADDR=' . $_SERVER['REMOTE_ADDR'];
                        break;
                    case array_key_exists('HTTP_X_FORWARDED_FOR' , $_SERVER):
                        $s_client_inf = 'HTTP_X_FORWARDED_FOR=' . $_SERVER['HTTP_X_FORWARDED_FOR'] . ' REMOTE_ADDR=' . $_SERVER['REMOTE_ADDR'];
                        break;
                    default:
                        $s_client_inf = 'REMOTE_ADDR=' . $_SERVER['REMOTE_ADDR'];
                }
                if( ini_get('display_errors') == 1 ){
                    //運用監視対象エラーメッセージ出力
                    if( $s_err_msg !== '') logger($s_err_msg . $s_client_inf . '::' . $a_ret['detail'] , 'E');
                    //監視対象外の情報出力
                    if( $s_info_msg !== '') logger($s_info_msg . $s_client_inf . '::' . $a_ret['detail']);
                }
            }
        }
    }
}