<?php
    define('PDEL_OFFICIAL_HOST' , 'pdel.vpsdemo.biz');
    define('PDEL_STAGING_HOST' , 'vpsdemo.biz');
    define('PDEL_USE_JQUERY_VER' , '1.8.2');
    define('PDEL_USE_JQUERY_UI_VER' , '1.9.1');
    define('PDEL_USE_BOOTSTRAP_VER' , '2.1.1');
    define('PDEL_USE_BOOTSTRAP_ICON_MENU_SIDE' , 'icon-list');
    define('PDEL_USE_BOOTSTRAP_ICON_MENU_OUT' , 'icon-share-alt');
    define('PDEL_USE_BOOTSTRAP_ICON_BTN' , 'icon-cog icon-white');
    define('PDEL_USE_BOOTSTRAP_ICON_BTN_DOWN_LOAD' , 'icon-download icon-white');
    define('PDEL_DEFAULT_LANG' , 'ja');
    define('PDEL_DEFAULT_TIME_ZONE' , 'Asia/Tokyo');
    define('PDEL_USE_BOOTSTRAP_SIDE_NAVI' , true);
    $pdel_user_lang = array_key_exists('HTTP_ACCEPT_LANGUAGE' , $_SERVER) === true ? $_SERVER['HTTP_ACCEPT_LANGUAGE'] : '';
    $pdel_user_lang = str_replace(';', ',', $pdel_user_lang);
    $pdel_a_tmp = explode(',', $pdel_user_lang);
    $guest_default_lang = '';
    $guest_default_locale = '';
    for($i=0;$i<count($pdel_a_tmp);$i++){
        $a_pdel_lang = explode('-', $pdel_a_tmp[$i]);
        if( $i === 0 ){
            $guest_default_lang = $a_pdel_lang[0];
            if( array_key_exists(1 , $a_pdel_lang) === true ) $guest_default_locale = $a_pdel_lang[1];;
            if( $guest_default_lang === PDEL_DEFAULT_LANG ){
                define('PDEL_GUEST_TYPE' , 0);
                break;
            }
        }
        else{
            if( $a_pdel_lang[0] === PDEL_DEFAULT_LANG ){
                define('PDEL_GUEST_TYPE' , 1);
                break;
            }
        }
    }
    switch($guest_default_lang){
        //case 'en':
            //define('PDEL_USE_LANG' , $guest_default_lang);
            //break;
        default:
            define('PDEL_USE_LANG' , PDEL_DEFAULT_LANG);
    }
    if( function_exists('date_default_timezone_set') === true ){
        switch($guest_default_locale){
        //    case 'US':
        //        date_default_timezone_set('America/New_York');
        //        break;
            default:
                date_default_timezone_set(PDEL_DEFAULT_TIME_ZONE);
        }
    }
    $i = count($a_pdel_lang) - 1;
    for(;$i >= 0;$i--){
        unset($a_pdel_lang[$i]);
    }
    $i = count($pdel_a_tmp) - 1;
    for(;$i >= 0;$i--){
        unset($pdel_a_tmp[$i]);
    }
    unset($pdel_user_lang , $guest_default_lang , $i , $pdel_a_tmp , $a_pdel_lang);
    function hsc($s){
        if( empty($s) === true ) return $s;
        $t = htmlspecialchars($s , ENT_QUOTES);
        $t = str_replace(' ' , '&nbsp;' , $t);
        if( PDEL_USE_LANG === PDEL_DEFAULT_LANG ) $t = str_replace("\\" , '&yen;' , $t);
        return $t;
    }
    function is_normal_file($file_name){
        if( is_string($file_name) === false ) return 1;
        if( strpos($file_name , chr(0)) !== false ) return 2;
        if( file_exists($file_name) === false) return 3;
        if( is_file($file_name) === false) return 4;
        if( is_readable($file_name) === false) return 5;
        return true;
    }
    function is_normal_dir($file_name){
        if( is_string($file_name) === false ) return 1;
        if( strpos($file_name , chr(0)) !== false ) return 2;
        if( file_exists($file_name) === false) return 3;
        if( is_dir($file_name) === false) return 4;
        if( is_readable($file_name) === false) return 5;
        return true;
    }
    function logger($msg , $msg_type = 'I'){
        if( ($msg_type !== 'I') and ($msg_type !== 'E') ) die('invalid logger function param');
        $log_stop_file = PDEL_LOG_DIR . '.LOG_STOP_FILE';
        if( is_normal_file($log_stop_file) === true ) return;
        $log_file = ($msg_type === 'I') ? (PDEL_LOG_DIR . 'info') : (PDEL_LOG_DIR . 'err');
        $now = array_key_exists('REQUEST_TIME' , $_SERVER) ? $_SERVER['REQUEST_TIME'] : time();
        $log_file = $log_file . date('Ymd' , $now) . '.log';
        $head = date('Y/m/d H:i:s' , $now) . ' (' . $_SERVER['REMOTE_ADDR'] . ':' . $_SERVER['REMOTE_PORT'] . ')';
        if( array_key_exists('REQUEST_METHOD' , $_SERVER) === true ) $head = $head . $_SERVER['REQUEST_METHOD'] . ':';
        $msg2 = is_string($msg) ? $msg : var_export($msg , true);
        $msg2 = $head . $msg2 . "\n";
        error_log($msg2 , 3 , $log_file);
    }
    function genTopNavi(){
        $html = <<< EOT_TOP_NAVI
<div class="navbar navbar-fixed-top">
<!--div class="navbar"-->
	<div class="navbar-inner">
		<div class="container">
			<a class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
			</a>
			<div class="nav-collapse">
				<ul class="nav">
                    {MENU0}
				</ul>
				<ul class="nav">
                    {MENU1}
				</ul>
				<ul class="nav">
                    {MENU2}
				</ul>
				<ul class="nav">
                    {MENU3}
				</ul>
				<ul class="nav">
                    {MENU4}
				</ul>
				<ul class="nav">
                    {MENU5}
				</ul>
				<ul class="nav">
                    {MENU6}
				</ul>
				<ul class="nav">
                    {MENU7}
				</ul>
			</div>
		</div>
	</div>
</div>
EOT_TOP_NAVI;
        switch(true){
            case (strcasecmp($_SERVER['HTTP_HOST'] , PDEL_OFFICIAL_HOST) === 0):
            case (strcasecmp($_SERVER['HTTP_HOST'] , PDEL_STAGING_HOST) === 0):
            case (preg_match('/.\.' . PDEL_STAGING_HOST . '$/' , $_SERVER['HTTP_HOST']) !== 0):
                $dl_env = true;
                break;
            default:
                $dl_env = false;
        }
        $item = array();
        $item[0] = '{PDEL_COM_i18n_MENU_index}';
        $item[1] = '{PDEL_COM_i18n_MENU_spec}';
        $item[2] = '{PDEL_COM_i18n_MENU_command}';
        $item[3] = '{PDEL_COM_i18n_MENU_usage}';
        $item[4] = '{PDEL_COM_i18n_MENU_demo_start}';
        $item[5] = '{PDEL_COM_i18n_MENU_tool}';
        $item[6] = '{PDEL_COM_i18n_MENU_glossary}';
        $item[7] = '{PDEL_COM_i18n_MENU_download}';
        $url = array();
        $url[0] = './';
        $url[1] = './spec.php';
        $url[2] = './command.php';
        $url[3] = './usage.php';
        $url[4] = './demo_start.php';
        $url[5] = './tool.php';
        $url[6] = './glossary.php';
        $url[7] = $dl_env ? ('./download.php') : ('http://' . PDEL_OFFICIAL_HOST . '/download.php');
        $new = array();
        $new[0] = false;
        $new[1] = false;
        $new[2] = false;
        $new[3] = false;
        $new[4] = false;
        $new[5] = false;
        $new[6] = false;
        $new[7] = !($dl_env);
        $side = array();
        $side[0] = true;
        $side[1] = true;
        $side[2] = true;
        $side[3] = true;
        $side[4] = false;
        $side[5] = false;
        $side[6] = true;
        $side[7] = false;

        $menu = array();
        for($n=0 ; $n < count($item);$n++){
            switch(true){
                case strpos($item[$n] , PDEL_ENTRY_SCRIPT) !== false:
                case PDEL_ENTRY_SCRIPT === 'demo_encrypt' and strpos($item[$n] , 'demo_start') !== false:
                    $menu[$n] = '<li class="active">';
                    break;
                default:
                    $menu[$n] = '<li>';
            }
            $menu[$n] = $menu[$n] . '<a href="' . $url[$n] . '"';
            if( $new[$n] === true ){
                $menu[$n] = $menu[$n] . ' target="_blank">';
            }
            else{
                $menu[$n] = $menu[$n] . '>';
            }
            if( $side[$n] === true ) $menu[$n] = $menu[$n] . '<i class="' . PDEL_USE_BOOTSTRAP_ICON_MENU_SIDE . '"></i>' . '&nbsp;';
            $menu[$n] = $menu[$n] . $item[$n];
            if( $new[$n] === true ) $menu[$n] = $menu[$n] . '<i class="' . PDEL_USE_BOOTSTRAP_ICON_MENU_OUT . '"></i>';
            $menu[$n] = $menu[$n] . '</a></li>';
            $html = str_replace(('{MENU' . $n . '}') , $menu[$n] , $html);
        }
        $html = $html . <<< EOT_HEADER
<header class="jumbotron subhead" id="overview">
  <div class="container">
    <h4>PDEL for PHP5{PDEL_SITE_TYPE}</h4>
    <p style="font-size:12px">Practical and Decryptable Encryption Library for PHP5{PDEL_VERSION}</p>
    <span class="pdel_code" style="allign:center">{PDEL_WELCOME_MSG}</span>
  </div>
</header>
EOT_HEADER;
        $version = defined('PDEL_CURRENT_VER') === true ? '&nbsp;&nbsp;&nbsp;(Version ' . PDEL_CURRENT_VER . ')': '';
        $html = str_replace('{PDEL_VERSION}' , $version , $html);
        if( defined('PDEL_GUEST_TYPE') === false ){
            $msg = 'Special thanks for your access. Sorry , this site is Japanese(UTF-8) version only.';
        }
        elseif(PDEL_GUEST_TYPE === 1){
            $msg = 'This site is Japanese(UTF-8) version only.';
        }
        else{
            $msg = '';
        }
        $html = str_replace('{PDEL_WELCOME_MSG}' , $msg , $html);
        if( strcasecmp($_SERVER['HTTP_HOST'] , PDEL_OFFICIAL_HOST) === 0 ){
    		$html = str_replace('{PDEL_SITE_TYPE}' , ' official website' , $html);
        }
        else{
    		$html = str_replace('{PDEL_SITE_TYPE}' , '' , $html);
        }
        return $html;
    }
    function replyInvalidRequest($i_type){
		$html = <<< EOT_HTML
<!DOCTYPE html>
<html lang="{PDEL_USE_LANG}">
<head>
<meta charset="utf-8">
<title>PDEL DEMO Error</title>
</head>
<body>
{REASON}
</body>
</html>
EOT_HTML;
        switch($i_type){
            case 1:
                $html = str_replace('{REASON}' , '{PDEL_COM_i18n_ERR_MSG_1}' , $html);
                break;
            case 2:
                $html = str_replace('{REASON}' , '{PDEL_COM_i18n_ERR_MSG_2}' , $html);
                break;
            default:
                $html = str_replace('{REASON}' , 'Unexpected HTTP-Request' , $html);
        }
        $html = getCommonLocaleResource($html);
        die($html);
    }
    function genHeader(){
        $html = <<< EOT_HEAD
<!DOCTYPE html>
<html lang="{PDEL_USE_LANG}">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>{PDEL-TITLE}</title>
<link rel="shortcut icon" href="./public_assets/org/img/favicon.ico" type="image/vnd.microsoft.icon">
<link rel="icon" href="./public_assets/org/img/favicon.ico" type="image/vnd.microsoft.icon">
<!--[if lt IE 9]>
    <script src="./public_assets/plugins/google/html5.js"></script>
    <script src="./public_assets/plugins/google/IE9.js"></script>
<![endif]-->
<link rel="stylesheet" href="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/css/bootstrap.min.css">
<link rel="stylesheet" href="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/css/bootstrap-responsive.min.css">
{PDEL-BS-NAVI-LINK}
<link rel="stylesheet" href="./public_assets/plugins/UI/{VER_JQUERY_UI}/css/ui-lightness/jquery-ui-{VER_JQUERY_UI}.custom.css">
<link rel="stylesheet" href="./public_assets/org/css/com.css">
<link rel="stylesheet" href="./public_assets/org/css/site_black.css">
<!-- link rel="stylesheet" href="./public_assets/org/css/site_blue.css" -->
<link rel="stylesheet" href="./public_assets/org/resource/{PDEL_USE_LANG}/css/_com.css">
{PDEL-ORG-CSS}
</head>
EOT_HEAD;
        $bs_navi_ver = false;
        $html = str_replace('{PDEL-TITLE}' , '{PDEL_COM_i18n_title_' . PDEL_ENTRY_SCRIPT . '}' , $html);
        switch(PDEL_ENTRY_SCRIPT){
            case 'demo_start':
            case 'demo_encrypt':
            case 'tool':
            case 'download':
                //$bs_navi_ver = false;
                $bs_navi_ver = true;
                break;
            default:
                $bs_navi_ver = true;
        }
        if( ($bs_navi_ver === true) and (defined('PDEL_USE_BOOTSTRAP_SIDE_NAVI') === true) ){
            $html = str_replace('{PDEL-BS-NAVI-LINK}' , '<link rel="stylesheet" href="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/css/docs.css">' , $html);
        }
        else{
            $html = str_replace('{PDEL-BS-NAVI-LINK}' , '' , $html);
        }
        $html = str_replace('{VER_BOOTSTRAP}' , PDEL_USE_BOOTSTRAP_VER , $html);
        $html = str_replace('{VER_JQUERY_UI}' , PDEL_USE_JQUERY_UI_VER , $html);
        $org_css = '<link rel="stylesheet" href="./public_assets/org/resource/{PDEL_USE_LANG}/css/_' . PDEL_ENTRY_SCRIPT . '.css';
        $org_css = $org_css . '">';
        $html = str_replace('{PDEL-ORG-CSS}' , $org_css , $html);
        if( ini_get('display_errors') == 1 ) $html = str_replace('.min.css' , '.css' , $html);//iniファイル系関数は挙動がバージョンによって異なるので===は用いない
        return $html;
    }
    function getMainHtml(){
        $file_name = PDEL_HOME . 'contents' . DIRECTORY_SEPARATOR . PDEL_ENTRY_SCRIPT . '.html';
        $html_main = file_get_contents($file_name);
        return $html_main;
    }
    function genJsLink(){
        $html = '<script src="./public_assets/engine/{VER_JQUERY}/jquery-{VER_JQUERY}.min.js"></script>' . "\n" .
                '<script src="./public_assets/plugins/UI/{VER_JQUERY_UI}/js/jquery-ui-{VER_JQUERY_UI}.custom.min.js"></script>' . "\n";
        switch(PDEL_ENTRY_SCRIPT){
            case 'demo_start':
            case 'demo_encrypt':
            case 'tool':
            case 'download':
                $bs_navi_ver = false;
                break;
            default:
                $bs_navi_ver = true;
        }
        if( ($bs_navi_ver === true) and (defined('PDEL_USE_BOOTSTRAP_SIDE_NAVI') === true) ){
            $html = $html . <<< EOT_JS_LINK1
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/bootstrap-transition.js"></script>
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/bootstrap-alert.js"></script>
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/bootstrap-modal.js"></script>
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/bootstrap-dropdown.js"></script>
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/bootstrap-scrollspy.js"></script>
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/bootstrap-tab.js"></script>
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/bootstrap-tooltip.js"></script>
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/bootstrap-popover.js"></script>
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/bootstrap-button.js"></script>
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/bootstrap-collapse.js"></script>
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/bootstrap-carousel.js"></script>
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/bootstrap-typeahead.js"></script>
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/bootstrap-affix.js"></script>
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/navi-ver/application.js"></script>
EOT_JS_LINK1;
        }
        else{
                $html = $html . <<< EOT_JS_LINK2
<script src="./public_assets/plugins/bootstrap/{VER_BOOTSTRAP}/js/bootstrap.min.js"></script>
EOT_JS_LINK2;
        }
        $html = $html . "\n" . '<script src="./public_assets/org/js/pdel_com.js"></script>';
        $html = str_replace('{VER_BOOTSTRAP}' , PDEL_USE_BOOTSTRAP_VER , $html);
        $html = str_replace('{VER_JQUERY}' , PDEL_USE_JQUERY_VER , $html);
        $html = str_replace('{VER_JQUERY_UI}' , PDEL_USE_JQUERY_UI_VER , $html);
        if( ini_get('display_errors') == 1 ) $html = str_replace('.min.js' , '.js' , $html);//iniファイル系関数は挙動がバージョンによって異なるので===は用いない
        return $html;
    }
    function genFooter(){
                $html = <<< EOT_FOOTER
<footer class="footer">
    <p style="text-align:center" class="pdel_code">PDEL for PHP5</p>
    <p style="text-align:center" class="pdel_code">Copyright &copy; 2012-2013 exceptionCatcher</p>
    <p style="text-align:center" class="pdel_code">Official website<br><a class="pdel_a pdel_code" href="http://pdel.vpsdemo.biz/" target="_blank">http://pdel.vpsdemo.biz/</a></p>
    <br>
    <p style="text-align:center" class="pdel_code">Blog<br><a class="pdel_a pdel_code" href="http://exceptioncatcher.seesaa.net/" target="_blank">http://exceptioncatcher.seesaa.net/</a></p>
</footer>
EOT_FOOTER;
        return $html;
    }
    function getStaticContent($dir , $name){
        $file_name = PDEL_HOME . 'contents'  . DIRECTORY_SEPARATOR . $dir . DIRECTORY_SEPARATOR . $name . '.html';
        $contents = file_get_contents($file_name);
        $contents = str_replace('pdel_red'  , '#cc0066' , $contents);
        $contents = str_replace('_pdel_blue_' , '#1e50a2' , $contents);
        return $contents;
    }
    function genSideNavi(){
        $html = <<< EOT_SIDE_NAVI
<div class="container">
    <div class="row">
        <div class="span3 bs-docs-sidebar" style="font-size:12px">
            <ul class="nav nav-list bs-docs-sidenav">
{PDEL-SIDE-LIST}
            </ul>
        </div>
        <div class="span9">
{PDEL-SIDE-CONTENT}
        </div>
    </div>
</div>
EOT_SIDE_NAVI;
        $side_list = '';
        $side_contents = '';
        $ini_file_name = PDEL_HOME . 'contents'  . DIRECTORY_SEPARATOR . PDEL_USE_LANG  . DIRECTORY_SEPARATOR . PDEL_ENTRY_SCRIPT . DIRECTORY_SEPARATOR . substr(PDEL_ENTRY_SCRIPT , 0 , 1) . 'menu.ini';
        $ini_array = parse_ini_file($ini_file_name , true);
        for($i1=1;;$i1++){
            if( array_key_exists($i1 , $ini_array['menu']) === false ){
                $menu_max = $i1 - 1;
                break;
            }
        }
        for($i1=0;$i1<=$menu_max;$i1++){
            if( $i1 === 0 ){
                $contents_file_name = dirname($ini_file_name) . DIRECTORY_SEPARATOR . '00.html';
                if( file_exists($contents_file_name) === true ){
                    $side_contents = $side_contents . file_get_contents($contents_file_name) . "\n";
                }
                continue;
            }
            for($i2=1;;$i2++){
                $ini_key = $i1 . '_' . $i2;
                if( array_key_exists($ini_key , $ini_array['menu']) === false ){
                    $sub_menu_max = $i2 - 1;
                    break;
                }
            }
            for($i2=0;$i2<=$sub_menu_max;$i2++){
                if( $i2 === 0 ){
                    $ini_key = $i1;
                    $display_id = $ini_key;
                }
                else{
                    $ini_key = $i1 . '_' . $i2;
                    $display_id = $i1 . '-' . $i2;
                }
                $item = explode(':' , $ini_array['menu'][$ini_key] , 2);
                $side_list = $side_list . '                <li><a href="#' . $item[0] . '"><span class="pdel_code">';
                if($i2 !== 0){
                    $side_list = $side_list . '&nbsp;' . '&nbsp;';
                    if($sub_menu_max >= 10 and $i2 < 10) $side_list = $side_list . '&nbsp;';
                }
                if( ($menu_max >= 10) and ($i1 < 10) )$side_list = $side_list . '&nbsp;';
                $side_list = $side_list . $display_id . '.</span>' . $item[1] . '</a></li>' . "\n";
                $contents_file_name = dirname($ini_file_name) . DIRECTORY_SEPARATOR;
                if( $i2 === 0 ){
                    $contents_file_name = $contents_file_name . sprintf("%02d" , $i1) . '.html';
                }
                else{
                    $contents_file_name = $contents_file_name . sprintf("%02d_%02d" , $i1 , $i2) . '.html';
                }
                $side_contents = $side_contents . '            <section id="' . $item[0] . '">' . "\n";
                $side_contents = $side_contents . '                <div class="page-header">' . "\n";
                $side_contents = $side_contents . '                    <h4>' . $display_id . '.' . mb_convert_kana($item[1] , 'KV') . '</h4>' . "\n";
                $side_contents = $side_contents . '                </div>' . "\n";
                $side_contents = $side_contents . '                <div class="lead pdel_basic">' . "\n";
                if( file_exists($contents_file_name) === true ){
                    $side_contents = $side_contents . file_get_contents($contents_file_name) . "\n";
                    $side_contents = str_replace('{PDEL-SIDE-NAVI-ID}' , $i1 , $side_contents);
                }
                else{
                    $side_contents = $side_contents . $item[1] . '{PDEL_COM_i18n_ERR_MSG_CONTENTS_NOT_FOUD1}' . basename($contents_file_name) . '{PDEL_COM_i18n_ERR_MSG_CONTENTS_NOT_FOUD2}' . "\n";
                }
                $side_contents = $side_contents . '                </div>' . "\n";
                $side_contents = $side_contents . '            </section>' . "\n";
            }
        }
        $html = str_replace('{PDEL-SIDE-LIST}' , $side_list , $html);
        $html = str_replace('{PDEL-SIDE-CONTENT}' , $side_contents , $html);
        return $html;
    }
    function getLocaleResource($html){
        $ini_file_name = PDEL_HOME . 'contents'  . DIRECTORY_SEPARATOR . PDEL_USE_LANG  . DIRECTORY_SEPARATOR . PDEL_ENTRY_SCRIPT . '.ini';
        $a_i18n_res = parse_ini_file($ini_file_name , false);
        foreach($a_i18n_res as $key => $value){
            $html = str_replace('{' . $key . '}' , $value , $html);
        }
        return $html;
    }
    function getCommonLocaleResource($html){
        $ini_file_name = PDEL_HOME . 'contents'  . DIRECTORY_SEPARATOR . PDEL_USE_LANG  . DIRECTORY_SEPARATOR . 'com.ini';
        $a_i18n_res = parse_ini_file($ini_file_name , false);
        foreach($a_i18n_res as $key => $value){
            $html = str_replace('{' . $key . '}' , $value , $html);
        }
        $html = str_replace('{PDEL_USE_LANG}' , PDEL_USE_LANG , $html);
        return $html;
    }
    function getPdelVersion($release_notes_dir){
        if( is_normal_dir($release_notes_dir) !== true ) return;
        $release_info = scandir($release_notes_dir , 1);
        if( $release_info === false ) return;
        for($i=0;$i<count($release_info);$i++){
            if( ($release_info[$i] === '..') or ($release_info[$i] === '.') ) continue;
            $file_name_info = explode('_', $release_info[$i]);
            if( count($file_name_info) !== 4 ) return;
            switch(true){
                case ctype_digit($file_name_info[0]) === false:
                case ctype_digit($file_name_info[1]) === false:
                case ctype_digit($file_name_info[2]) === false:
                case ctype_digit($file_name_info[3]) === false:
                case strlen($file_name_info[0]) !== 8:
                    return;
            }
            if( checkdate(intval(substr($file_name_info[0] , 4 , 2)) , intval(substr($file_name_info[0] , 6 , 2)) , intval(substr($file_name_info[0] , 0 , 4))) === false ) return;
            define('PDEL_CURRENT_VER' , $file_name_info[1] . '.' . $file_name_info[2] . '.' . $file_name_info[3]);
            define('PDEL_LAST_RELEASE' , $file_name_info[0]);
            define('PDEL_RELEASE_NOTES_DIR' , $release_notes_dir . DIRECTORY_SEPARATOR);
            break;
        }
        if(defined('PDEL_CURRENT_VER') === true);
    }